from charms.reactive import when_any, when_not
from charms.reactive import set_flag, clear_flag
from charms.reactive import Endpoint


class GenericIPPortUserPassRequires(Endpoint):

    @when_any('endpoint.{endpoint_name}.changed.ip',
              'endpoint.{endpoint_name}.changed.port',
              'endpoint.{endpoint_name}.changed.user',
              'endpoint.{endpoint_name}.changed.password')
    def mailman3_connected(self):
        set_flag(self.expand_name('endpoint.{endpoint_name}.connected'))
        clear_flag(self.expand_name('endpoint.{endpoint_name}.changed.ip'))
        clear_flag(self.expand_name('endpoint.{endpoint_name}.changed.port'))
        clear_flag(self.expand_name('endpoint.{endpoint_name}.changed.user'))
        clear_flag(self.expand_name('endpoint.{endpoint_name}.changed.password'))

    @when_not('endpoint.{endpoint_name}.joined')
    def broken(self):
        clear_flag(self.expand_name('endpoint.{endpoint_name}.connected'))

    def mailman3(self):
        mailman3 = []
        for relation in self.relations:
            print("Requires relation")
            print(relation.relation_id)
            for unit in relation.joined_units:
                print("requires unit")
                print(unit.received)
                mailman3.append({
                    'ip': unit.received['ip'],
                    'port': unit.received['port'],
                    'user': unit.received['user'],
                    'password': unit.received['password'],
                    })
        return mailman3
